"""
_HTTPfetcher_

This class is used to fetch the json data from a DAS url.
The Json object is expected to be Dictionary typed
 
"""

from types import *
import simplejson as json
import urllib2

class HTTPfetcher(object):
  data=[]
  sInfo=dict()
	
  def __init__(self,url):
    self.url=url
    self.req = urllib2.Request(self.url) 
    self.req.add_header("Content-type","application/x-www-form-urlencoded")
    self.req.add_header("Accept","application/json")
    
  def execute(self):
    try: 
     self.response = urllib2.urlopen(self.req)
     self.jsonRaw = self.response.read()
     self.status=0
     jsonObj = json.loads(self.jsonRaw)
     
     if type(jsonObj) is ListType:
        self.data=jsonObj
        self.sInfo={}
     elif  type(jsonObj) is DictType:
       if jsonObj.has_key('results'):
         self.data= jsonObj['results']
         self.sInfo =dict(self.jsonObj)
         del self.sInfo['results']
        #data is a list of dictionaries
       elif jsonObj.has_key('Exception'):
         self.data = [str(jsonObj['Exception']),str(jsonObj['Exception_type'])]
         self.sInfo=jsonObj
     else: self.data= jsonObj
      # hold exception on the data
    except Exception, e:
      self.status=1
      self.data=[str(e)]
      try:
       self.sInfo=jsonObj
      except:
       pass
    #fix  1-record long data to list type
    if type(self.data) is not ListType:
       self.data =[self.data, ]
    return self.status
	
  def getServiceInfo(self):
    return self.sInfo
   