"""
_MotT0 request handler_
 This class sorts out the different MotT0 requests
"""

from WMCore.WebTools.Page import TemplatedPage
from cherrypy import expose
from MotT0Index import MotT0Index
from MotT0Detail import MotT0Detail
from MotT0Run import MotT0Run
from MotT0History import MotT0History


import cherrypy
import os

class MotT0(TemplatedPage):
    """
    MotT0 main page
    """
    PATH = os.path.abspath(os.path.dirname(__file__))
    _cp_config = {'tools.staticdir.on' : True,
                  'tools.staticdir.dir' : PATH+"/imgs/",
                  #'tools.staticdir.index' : 'heart-beat.gif',
    }
      
    @expose
    def index(self, **kwargs):
        return self.default(kwargs=kwargs)
    
    @expose
    def default(self, *args, **kwargs):
     #args contains the page name to be displaied
     #kwargs contains the parameres
     
     #increase Cherrypy Timeout
     cherrypy.config.update({'tools.expires.secs': 800,'tools.expires.on':False})
     cherrypy.tools.expires.sec= 800
     cherrypy.response.timeout = 800
     #print "CherryPy Timeout:"+str(cherrypy.response.timeout) +"  "+str(cherrypy.config['tools.expires.secs'])
     
     #print str(args) + str(kwargs)
     if len(args)==0 or args[0]=='system':
       #print "PAGE: system"
       page=MotT0Index(kwargs,self.config.DAS,self.templatedir+"/")
     else:
       if args[0]=='detail':
          page=MotT0Detail(kwargs,self.config.DAS,self.templatedir+"/")
       if args[0]=='run':
          page=MotT0Run(kwargs,self.config.DAS,self.templatedir+"/")
       if args[0]=='history':
          page=MotT0History(kwargs,self.config.DAS,self.templatedir+"/")
       #add other pages!
     return page.getTemplate()