"""
_MotT0History Page_

This page fetch an entire set of table and then organize/print it in a easy understandable way
 
""" 
from WMCore.WebTools.Page import TemplatedPage

from Table import *
import TableContents 

class MotT0History(TemplatedPage):
    title="MotT0 history page"
    step=10
    streamerCode=""
    otherTablesCode=""
    vtypes={"StreamerFiles":'Strm',
     "RepackFiles":"Repkf","RepackJobs":"Repkj","RepackMergeJobs":"Repkmj","RepackMergeFiles":"Repkmf",
     "RecoFiles":"Recof","RecoJobs":"Recoj","RecoMergeJobs":"Recomj","RecoMergeFiles":"Recomf",
     "AlcaFiles":"Alcaf","AlcaJobs":"Alcaj","AlcaMergeJobs":"Alcamj","AlcaMergeFiles":"Alcamf",
     "ExpressFiles":"Exprf","ExpressJobs":"exprj","ExpressMergeJobs":"Exprmj","ExpressMergeFiles":"Exprmf"}
    codes={}
    def __init__(self, kwords,DASUrl,templatedir):
      self.params=kwords
      self.templatedir = templatedir
      
      #generate code for tables
      
      try:
        self.firstTable=self.params['source']
        self.value=self.params['Id']
        
        if self.firstTable not in self.vtypes.keys(): 
          raise Exception('wrong table name:'+self.firstTable +" NOT in "+str(self.vtypes.keys()))
        #print str(self.params)
        dataTable= Table(DASUrl,"allhistory?vtype="+self.vtypes[self.firstTable]+"&value="+self.value)
        data =dataTable.getData()
        code=""
        self.codes={}
        for tabledata in data:
          for raw in tabledata:
            if 'tablename' in raw:
               tableName=raw['tablename']
               tempData=[]
            else: tempData.append(raw)
          #print "Table :"+ tableName+ "   "+ str(tempData)
          tableContent=self.getContent(tableName)
          if tableContent!=None:
             self.codes[tableName]=dataTable.genericTableCode(tableContent.colDecorators,tableContent.title,data=tempData)
        
        ##organize output
        try:
         self.streamerCode=self.codes['StreamerFiles']
         if self.firstTable=="StreamerFiles": self.streamerCode=self.addBlueBorder(self.streamerCode)
        except:
          self.streamerCode=" "
        self.otherTablesCode+=self.makeLayer("Express",self.vtypes.keys(),'expressBG')
        self.otherTablesCode+=self.makeLayer("Repack", self.vtypes.keys(),'repackBG')
        self.otherTablesCode+=self.makeLayer("Reco",   self.vtypes.keys(),'recoBG')
        self.otherTablesCode+=self.makeLayer("Alca",   self.vtypes.keys(),'alcaBG')
        
      except ConnectionException, e:
        setattr(self,''+e.name+'Code',"<B> Connection Error </B>")
      if self.streamerCode=="":
        self.streamerCode="<B>Conncetion Error or wrong request</B>"
      if self.otherTablesCode=="":
        self.otherTablesCode="<B>Conncetion Error or wrong request</B>"
      
    def getContent(self,name):
     try:
       methodToCall = getattr(TableContents, 'H'+name)
       content=methodToCall(self.params)
       return content
     except Exception,e:
       print "Content not found for table: "+name + "  "+str(e)
       return None
      
    
    def addBlueBorder(self,code):
      return "<table style=\"border: 5px solid blue;\"><tr><td>"+ code+ "</td></tr></table>"
    
    def makeLayer(self,prefix,names,CSSclass=""):
      code="<table  border=\"0\" >  <tr > <td class=\""+CSSclass+"\" colspan=\"4\" > <b>"+prefix+ " Data<b/></td></tr>"
      try:
         code+="<tr>"
         for suffix in ["Jobs","Files","MergeJobs","MergeFiles"]:
           tableName=prefix+suffix 
           if tableName==self.firstTable: 
                 code+="<td class=\""+CSSclass+"\">"+self.addBlueBorder(self.codes[tableName])+"</td>"
           else: code+="<td class=\""+CSSclass+"\">"+self.codes[tableName]+"</td>"
         code+="</tr></table><br/>"
      except Exception, e:
        #print str(e)
        return ""
      return code
        
    def getTemplate(self):
       params={
            "title": self.title,
            #"time" : ctime(),
            "tmplPath": self.templatedir,
            "streamerTable": self.streamerCode,
            "otherTables":self.otherTablesCode
              }
       return self.templatepage('history', **params )
    
    