"""
__statistics__
"""

from WMCore.WebTools.Page import TemplatedPage
from HTTPfetcher import HTTPfetcher
from types import *
from Table import *
from time import *


class Statistics(Table):
  name='stats'

  tableTop="""<table border="0">
<tbody><tr><th colspan="2">%s</th></tr>"""
  tableRow="""
<tr><td style="background-color: white;">%s</td><td style="background-color: white;"><a href="%s">%s</a></td></tr>"""
  tableFoot="""</tbody></table></div></td>""" 
    
  def __init__(self,DASUrl,runid=""):
    self.runid=runid
    self.DASUrl=DASUrl
    
  def buildStatsCode(self):
      
      tables=[expressTable(),expressMergeTable(),repackTable(),repackMergeTable(),recoTable(),recoMergeTable(),alcaTable(),alcaMergeTable()]
      
      
      statCode="""<table>
  <tr  ><td class="stats" colspan="4"> <b> Statistics:</b></td>
  </tr><tr>"""
      #print "Tables=="+str(len(tables))+str(tables)
      for table in tables:
        #print table.title
        tableCode="""<td class="stats">
                     <div style="float:left;padding-right:10px;"> """
        if table.tableNames==[]: # 
         tdata=self.fetcher(self.DASUrl+table.suffix%(str(self.runid)))
        else:                    # 
          tdata=[]
          for name in table.tableNames:
            singleData=self.fetcher(self.DASUrl+table.suffix%(str(self.runid),name))[0]
            if len(singleData)>0: tdata.append(singleData)
        #values=[]
        tableCode+=self.tableTop %(table.title)
        #print tdata
        for i in range(0,len(tdata)):
         try:
           tableCode+=self.tableRow% (str(tdata[i][table.attrStatus]),table.link%(str(self.runid),str(tdata[i][table.attrStatus])),str(tdata[i][table.attrCount]))
         except Exception, e:
          print "Exception: "+str(e)
        tableCode+=self.tableFoot
        statCode+=tableCode
        if tables.index(table)%4==3 and tables.index(table)+1<len(tables) : statCode+="</tr><tr>" 
      statCode+="""</tr></table>"""
      return statCode
        
#########################################################################################################################
class statTable(object):
  title="Table"
  attrStatus="status"
  attrCount="count"
  suffix=""
  tableNames=["acquired", "complete", "failed"]
  
class simpleStatTable(statTable):
    tableNames=[]

class expressTable(simpleStatTable):
  title="Express stats"
  suffix="statsexpress?run=%s"
  link="detail?table=express&run=%s&status=%s"
  
class repackTable(simpleStatTable):
  title="Repack stats"
  suffix="statsrepack?run=%s"
  link="detail?table=repack&run=%s&status=%s" 
     
     
class expressMergeTable(simpleStatTable):
  title="Express Merge stats"
  #suffix="statsexpressmerge?run=%s&table=%s"
  suffix="statsexpressmerge?run=%s"
  link="detail?table=expressMerge&run=%s&status=%s"
  
class repackMergeTable(simpleStatTable):
  title="Repack Merge stats"
  suffix="statsrepackmerge?run=%s"
  link="detail?table=repackMerge&run=%s&status=%s"
  
class recoTable(simpleStatTable):
  title="Reco stats"
  suffix="statsreco?run=%s"
  link="detail?table=reco&run=%s&status=%s" 

class recoMergeTable(simpleStatTable):
  title="Reco Merge stats"
  suffix="statsrecomerge?run=%s"
  link="detail?table=recoMerge&run=%s&status=%s"
  
class alcaTable(simpleStatTable):
  title="AlcaSkim stats"
  suffix="statsalca?run=%s"
  link="detail?table=alca&run=%s&status=%s" 

class alcaMergeTable(simpleStatTable):
  title="AlcaSkim Merge stats"
  suffix="statsalcamerge?run=%s"
  link="detail?table=alcaMerge&run=%s&status=%s" 