from HTTPfetcher import HTTPfetcher
from TableContents import *
 
class Table(object):
   """
This class can fetch the data from DAS and format a HTML table based on the received data
   """ 
   name='generic'
   
   def __init__(self,DASUrl,suffix="",tableStepSize=10):
    url = DASUrl+suffix
    self.DASUrl=DASUrl
    self.tableStepSize=tableStepSize
    #fetch information: used only for 1 table
    if len(suffix)>0: self.data=self.fetcher(url)

   def getData(self):
     return self.data
   
   def fetcher(self,url):
     #print "connecting to "+url
     f = HTTPfetcher(url)
     stat =f.execute()
     if stat>0:
      raise ConnectionException(self.name,'Connection error')
     #print "DATA"+str(f.data)
     return f.data
   
   
   def longTableCode(self,content,linkPage):
      """
      the table which calls this method wants the data to be limited 
      """
      self.content=content
      self.linkPage=linkPage
      return self.genericTableCode(content.colDecorators,content.title)
   
   
   def genericTableCode(self, cols,title,data={}):
      """
      HTML Code generation for the fetched data, according with the colDecorators and the table title
      """
      if data=={}: data=self.data
      tableTop="""<table border="0" cellspacing="2">
                  <tbody><tr><th colspan=" """+str(len(cols)) +""""  align="center" > """ +title+"""</th></tr>"""
      tableBody=""
      tableTop+="<tr>"
      for c in cols:
         tableTop+="""<td style="background-color: rgb(185, 208, 222);"> """+c.colName+"</td>"
      tableTop+="</tr>"
      bkground=""   
      for v in data:
         #print "line="+str(v)
         tableBody+="<tr>"
         if bkground=="": bkground=""" style="background-color: white;" """
         else: bkground=""
         for i in cols:
           try: 
            values=[]
            for attr in i.attrNames:
              values.append(str(v[attr]))
            if hasattr(i,'getAuxInfo'):  # graphs need more information: specific ones for every run
              values+=i.getAuxInfo(self,v)
            #print "VALUES="+str(values)
            tableBody+="<td"+bkground+">"+i.decorator(values)+"</td>"
           except Exception, e:
              print "Exception: "+str(e) +"  "+str(v)
              tableBody+="<td"+bkground+">"+"No column attribute found"+"</td>"    
         tableBody+="</tr>"
      ## links must be added ONLY if the table is a "long" one
      if hasattr(self,'content'):
         tableBody+=self.getLinks(self.content,data)
      tableBody+="</tbody></table>"   
      return tableTop+tableBody

   def getLinks(self,content,data):
        ## set up  next/prevous page links for longTables
        linksCode="""<tr><td style="background-color: rgb(185, 208, 222);" colspan=" """+str(len(content.colDecorators)) +""""  align="center" >"""
        if content.page>1:
           linksCode+=" <a href=\""+self.linkPage+"&table="+content.name+"&page="+str(content.page-1)+"\">Previous Values</a>&nbsp;&nbsp;&nbsp; "
        linksCode+="&nbsp;&nbsp; ---Page # "+str(content.page)+"--- &nbsp;&nbsp;"
        if len(data)>=content.tableStepSize:
           linksCode+="&nbsp;&nbsp; <a href=\""+self.linkPage+"&table="+content.name+"&page="+str(content.page+1)+"\">Next Values</a>"
        linksCode+="</td></tr>"
        return linksCode
               
class ConnectionException(Exception):
    """Exception raised for errors 
    """
    def __init__(self, name, msg):
        self.name = name
        self.msg = msg

 