from Table import *
from Columns import *


class content(object):
  """
This class represent the SuperClass of every table content information.
Every table may have different title/URL/CSSclass and columns!
The __init__ method is also used to set the page attribute: in long table this decide the limits of the data
  """ 
  page=1
  def __init__(self,params,tableStepSize=10):
    self.tableStepSize=tableStepSize
    self.downLimit =0 
    self.upLimit  = self.tableStepSize
    #print "PARAMS:"+str(params) + str(self.name ) 
    try:
       #print "PARAMS:"+str(params) + str(self.name )
       if str(params['table']) ==self.name:
         #if more values of ['table'] this is ignored.
         self.page=int(params['page'])
         if (self.page<1):self.page=1
         self.downLimit =(self.page -1) * self.tableStepSize 
         self.upLimit=self.downLimit+self.tableStepSize
         #print "params for="+str(params['table'])+ "   "  + str(self.downLimit)+"  "+str(self.upLimit)
    except Exception, e:
       pass
       #print str(e)
       
#################################################################################################3
class runDetailContent(content):
   name='runDetails'
   title="Runs: %s"
   page=1
   colDecorators=[RunId(),sTime(),eTime(),process(),version(),expVersion(),repVersion(),hlt(),
           acq(),status(),numstreamers(),expressGraph(),repackGraph(),recoGraph(),alcaGraph()]
############################################ main page tables

class exprJ(content):
  name='exprJ'
  CSSclass='expressBG'
  URL='expressnewusedjobs'
  title="Express New and Used Jobs"
  path='history?source=Express'
  colDecorators=[JobId(path),RunId(),defTime(),nstreamers()]

class exprMJ(content):
  name='exprMJ'
  CSSclass='expressBG'
  URL='expressmergelastjobs'
  title="Express Merge Acquired Jobs"
  path='history?source=ExpressMerge'
  colDecorators=[JobId(path),RunId(),defTime(),filesNum()]  
    
class repkJ(content):
  name='repkJ'
  CSSclass='repackBG'
  URL='repacklastacquired'
  title="Repack running Jobs"
  path='history?source=Repack'
  colDecorators=[JobId(path),RunId(),runTime(attrNames=["def_time"]),nstreamers(),stream()]
  
class repkMJ(content):
  name='repkMJ'
  CSSclass='repackBG'
  URL='repackmergelastacquired'
  title="Repack Merge Acquired Jobs"
  path='history?source=RepackMerge'
  colDecorators=[JobId(path),RunId(),defTime(attrNames=["state_time"]),filesNum(),dataset()]  
  
class recoJ(content):
  name='recoJ'
  CSSclass='recoBG'
  URL='recolastacquired'
  title="Reconstruction Acquired Jobs"
  path='history?source=Reco'
  colDecorators=[JobId(path),RunId(),defTime(attrNames=["state_time"]),filesNum(),dataset()]
  
class recoMJ(content):
  name='recoMJ'
  CSSclass='recoBG'
  URL='recomergelastacquired'
  title="Reco Merge Acquired Jobs"
  path='history?source=RecoMerge'
  colDecorators=[JobId(path),RunId(),defTime(attrNames=["state_time"]),filesNum(),dataset()]
    
class alcaJ(content):
  name='alcaJ'
  CSSclass='alcaBG'
  URL='alcalastacquired'
  title="Alcaskim Acquired Jobs"
  path='history?source=Alca'
  colDecorators=[JobId(path),RunId(),defTime(attrNames=["state_time"]),filesNum(),dataset()]
  
class alcaMJ(content):
  name='alcaMJ'
  CSSclass='alcaBG'
  URL='alcamergelastacquired'
  title="AlcaSkim Merge Acquired Jobs"
  path='history?source=AlcaMerge'
  colDecorators=[JobId(path),RunId(),defTime(attrNames=["state_time"]),filesNum(),dataset()]
    
################################################################################ detail tables

class exprJByStatus(exprJ):
  name='express'
  URL='expressjobsbystatus'
  title="Express %s Jobs"
  
  
class exprMJByStatus(exprMJ):
  name='expressMerge'
  URL='expressmergejobsbystatus'
  title="Express Merge %s Jobs"  
  colDecorators=[JobId(path='history?source=ExpressMerge'),RunId(),defTime(attrNames=["state_time"]),filesNum()]  
  
class repkJByStatus(repkJ):
  name='repack'
  URL='repackjobsbystatus'
  title="Repack %s Jobs"
 
  
class repkMJByStatus(repkMJ):
  name='repackMerge'
  URL='repackmergejobsbystatus'
  title="Repack Merge %s Jobs"

  
class recoJByStatus(recoJ):
  name='reco'
  URL='recojobsbystatus'
  title="Reconstruction %s Jobs"
  
class recoMJByStatus(recoMJ):
  name='recoMerge'
  URL='recomergejobsbystatus'
  title="Reco Merge %s Jobs"
    
class alcaJByStatus(alcaJ):
  name='alca'
  URL='alcajobsbystatus'
  title="Alcaskim %s Jobs"
  
class alcaMJByStatus(alcaMJ):
  name='alcaMerge'
  URL='alcamergejobsbystatus'
  title="AlcaSkim Merge %s Jobs"
  
########################################### run page tables
class streamers(content):
  name='streamers'
  #CSSclass='expressBG'
  URL='runstreamers?run=%s'
  title="Streamers files"
  path='history?source=Streamer'
  colDecorators=[StreamerId(path),lumiId(),filesize(),events(),stream(),lfn()]
  #BUG FIX: deleted exportable() column
  
class exprTF(content):
  name='exprTF'
  CSSclass='expressBG'
  URL='runtempexpressfiles?run=%s'
  title="Temporary Express files"
  path='history?source=Express'
  colDecorators=[FileId(path),filesize(),events(),lfn()]
  
class exprF(content):
  name='exprF'
  CSSclass='expressBG'
  URL='runexpressfiles?run=%s'
  title="Express Files"
  path='history?source=ExpressMerge'
  colDecorators=[FileId(path),filesize(),events(),lfn()]  
    
class repkTF(content):
  name='repkTF'
  CSSclass='repackBG'
  URL='runtemprepackfiles?run=%s'
  title="Temporary Repack files"
  path='history?source=Repack'
  colDecorators=[FileId(path),filesize(),events(),lfn()]
  
class repkF(content):
  name='repkF'
  CSSclass='repackBG'
  URL='runrepackfiles?run=%s'
  title=" Repack files"
  path='history?source=RepackMerge'
  colDecorators=[FileId(path),filesize(),events(),lfn()] 
  
class recoTF(content):
  name='recoTF'
  CSSclass='recoBG'
  URL='runtemprecofiles?run=%s'
  title="Temporary Reconstruction Files"
  path='history?source=Reco'
  colDecorators=[FileId(path),filesize(),events(),tier(),dataset(),lfn()]
  
class recoF(content):
  name='recoF'
  CSSclass='recoBG'
  URL='runrecofiles?run=%s'
  title="Reconstruction Files"
  path='history?source=RecoMerge'
  colDecorators=[FileId(path),filesize(),events(),dataset(),lfn()]
    
class alcaTF(content):
  name='alcaTF'
  CSSclass='alcaBG'
  URL='runtempalcafiles?run=%s'
  title="Temporary Alcaskim Files"
  path='history?source=Alca'
  colDecorators=[FileId(path),filesize(),events(),dataset(),skim(),lfn()]
  
class alcaF(content):
  name='alcaF'
  CSSclass='alcaBG'
  URL='runalcafiles?run=%s'
  title="AlcaSkim Files"
  path='history?source=AlcaMerge'
  colDecorators=[FileId(path),filesize(),events(),dataset(),skim(),lfn()]

############################################################################ History tables
    
class HStreamerFiles(streamers):
  title="Streamers"

#############################
class HExpressJobs(exprJ):
  title=" Express Jobs"

class HExpressFiles(exprF):
  path='history?source=Express'
  title="Temporary Express Files"
  colDecorators=[FileId(path),filesize(),events(),lfn()]

class HExpressMergeJobs(exprMJ):
  title=" Express Merge Jobs"

class HExpressMergeFiles(exprTF):
  path='history?source=ExpressMerge'
  title=" Express Files"
  colDecorators=[FileId(path),filesize(),events(),lfn()]
  
#############################
class HRepackJobs(content):
  title=" Repack Jobs"
  path='history?source=Repack'
  colDecorators=[JobId(path),RunId(),defTime(),nstreamers(),stream(),status()]
  
class HRepackFiles(content):
  path='history?source=Repack'
  title="Temporary Repack Files"
  colDecorators=[FileId(path),filesize(),events(),dataset(),lfn()]


class HRepackMergeJobs(content):
  title=" Repack Merge Jobs"
  path='history?source=RepackMerge'
  colDecorators=[JobId(path),RunId(),filesNum(),dataset()]  
  
class HRepackMergeFiles(content):
  path='history?source=RepackMerge'
  title="Repack Files"
  colDecorators=[FileId(path),filesize(),events(),dataset(),lfn()]
#############################
class HRecoJobs(content):
  title=" Reco Jobs"
  path='history?source=Reco'
  colDecorators=[JobId(path),RunId(),defTime(),filesNum(),dataset()]
  
class HRecoFiles(content):
  path='history?source=Reco'
  title="Temporary Reco Files"
  colDecorators=[FileId(path),filesize(),events(),tier(),dataset(),lfn()]


class HRecoMergeJobs(content):
  title=" Reco Merge Jobs"
  path='history?source=RecoMerge'
  colDecorators=[JobId(path),RunId(),defTime(),filesNum(),dataset()]  
  
class HRecoMergeFiles(content):
  path='history?source=RecoMerge'
  title=" Reco Files "
  colDecorators=[FileId(path),filesize(),events(),dataset(),lfn()]
#############################
class HAlcaJobs(content):
  title=" Alca Jobs"
  path='history?source=Alca'
  colDecorators=[JobId(path),RunId(),defTime(),filesNum(),dataset(),skim()]
  
class HAlcaFiles(content):
  path='history?source=Alca'
  title="Temporary Alca Files"
  colDecorators=[FileId(path),filesize(),events(),skim(),dataset(),lfn()]


class HAlcaMergeJobs(content):
  title=" Alca Merge Jobs"
  path='history?source=AlcaMerge'
  colDecorators=[JobId(path),RunId(),defTime(),filesNum(),skim(),dataset()]  
  
class HAlcaMergeFiles(content):
  path='history?source=AlcaMerge'
  title=" Alca Files"
  colDecorators=[FileId(path),filesize(),events(),skim(),dataset(),lfn()]
